VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsControl"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Type ClassType
    Username As String
End Type
Dim Class As ClassType

Const TotalOptions = 12

Public ServerList As ListBox

Property Let Username(UN As String)
    Class.Username = UN
End Property

Property Get Username() As String
    Class.Username = Username
End Property

Sub SendMessage(Message As String, Index As Integer, ErrData As String)
    If Client(Index).InUse = True And Client(Index).Mode = modeServer Then
        SendSocket Index, Chr$(4) + Message
    Else
        ErrData = "ErrNum=1" + vbCrLf + "ErrDesc=Client index not found or not in server mode" + vbCrLf + "Name=SendMessage"
    End If
End Sub

Sub SendMessageToAll(Message As String, Optional ErrData As String)
    Dim a As Integer
    
    For a = 1 To MaxClients
        If Client(a).InUse = True And Client(a).Mode = modeServer Then
            SendSocket a, Chr$(4) + Message
        End If
    Next a
    
    PrintOutput "Server Message: " + Message
End Sub

Sub ShutdownServer(Reason As String, Optional ErrData As String)
    'AppendLog "The server was shut down by " + Username
    modServerRegistry.ShutdownServer
End Sub

Sub GetServerInfo(Index As Long, ServerID As String, ServerName As String, IP As String, PlayerCount As Long, Official As Long, Optional ErrData As String)
'Sub GetServerInfo(Index As Long, ServerID As String, ServerName As String, IP As String)
    With Client(Index)
        If .InUse = True Then
            ServerID = .User
            ServerName = .Name
            IP = .IP
            PlayerCount = .PlayerCount
            Official = .Official
        Else
            ErrData = "ErrNum=3" + vbCrLf + "ErrDesc=Client index not found or not in server mode" + vbCrLf + "Name=GetServerInfo"
        End If
    End With
End Sub

Sub BootServer(Index As Integer, Optional ErrData As String)
    If Client(Index).InUse = True And Client(Index).Mode = modeServer Then
        CloseClientSocket CLng(Index)
    Else
        ErrData = "ErrNum=2" + vbCrLf + "ErrDesc=Client index not found or not in server mode" + vbCrLf + "Name=BootServer"
    End If
End Sub

Sub GetAccountData(User As String, Password As String, Name As String, Description As String, UpdateURL As String, Official As Byte, Optional ErrData As String)
    If User = "" Then GoTo Error
    
    ServerRS.Seek "=", User
    
    If ServerRS.NoMatch = False Then
        Password = ServerRS!Password & ""
        Name = ServerRS!Name & ""
        Description = ServerRS!Description & ""
        UpdateURL = ServerRS!UpdateURL & ""
        Official = ServerRS!Official
    Else
Error:
        ErrData = "ErrNum=4" + vbCrLf + "ErrDesc=Account not found in database" + vbCrLf + "Name=GetAccountData"
    End If
End Sub

Sub GetBanData(BanName As String, IP As String, UnbanDate As String, Reason As String, Optional ErrData As String)
    If BanRS.RecordCount = 0 Then Exit Sub
    
    If BanName = "" Then GoTo Error
    
    BanRS.FindFirst "Name='" + BanName + "'"
    
    If BanRS.NoMatch = False Then
        IP = BanRS!IP & ""
        UnbanDate = BanRS!UnbanDate & ""
        Reason = BanRS!Reason & ""
    Else
Error:
        ErrData = "ErrNum=5" + vbCrLf + "ErrDesc=Ban name not found in database" + vbCrLf + "Name=GetBanData"
    End If
End Sub

Function FindServer(User As String) As Integer
    FindServer = CInt(modServerRegistry.FindServer(User))
End Function

Sub CreateAccount(User As String, Password As String, Name As String, Description As String, UpdateURL As String, Official As Byte, Optional ErrData As String)
    If ServerRS.RecordCount > 0 Then
        ServerRS.Seek "=", User
        
        If ServerRS.NoMatch = False Then
            ErrData = "ErrNum=6" + vbCrLf + "ErrDesc=The username selected already exists" + vbCrLf + "Name=CreateAccount"
            Exit Sub
        End If
    End If

    ServerRS.AddNew
    
    ServerRS!User = User
    ServerRS!Password = Password
    ServerRS!Name = Name
    ServerRS!Description = Description
    ServerRS!UpdateURL = UpdateURL
    ServerRS!Official = Official
    
    ServerRS.Update
End Sub

Sub EditAccount(User As String, Password As String, Name As String, Description As String, UpdateURL As String, Official As Byte, Optional ErrData As String)
    If ServerRS.RecordCount = 0 Then GoTo Error
    
    ServerRS.Seek "=", User
        
    If ServerRS.NoMatch = True Then
Error:
        ErrData = "ErrNum=7" + vbCrLf + "ErrDesc=The username selected doesn't exist" + vbCrLf + "Name=EditAccount"
        Exit Sub
    End If

    ServerRS.Edit
    
    'ServerRS!User = User
    ServerRS!Password = Password
    ServerRS!Name = Name
    ServerRS!Description = Description
    ServerRS!UpdateURL = UpdateURL
    ServerRS!Official = Official
    
    ServerRS.Update
End Sub

Sub CreateBan(BanName As String, IP As String, UnbanDate As Date, Reason As String, Optional ErrData As String)
    If BanName = "" Or IP = "" Then
        ErrData = "ErrNum=9" + vbCrLf + "ErrDesc=A ban name and IP must be entered" + vbCrLf + "Name=CreateBan"
        Exit Sub
    End If

    If BanRS.RecordCount > 0 Then
        BanRS.FindFirst "Name='" + BanName + "'"
        
        If BanRS.NoMatch = False Then
            ErrData = "ErrNum=8" + vbCrLf + "ErrDesc=The ban name specified already exists" + vbCrLf + "Name=CreateBan"
            Exit Sub
        End If
    End If
    
    BanRS.AddNew
     
    BanRS!Number = 0
    BanRS!Name = BanName
    BanRS!IP = IP
    BanRS!UnbanDate = UnbanDate
    
    If Reason <> "" Then
        BanRS!Reason = Reason
    Else
        BanRS!Reason = Null
    End If
    
    BanRS.Update
End Sub

Sub EditBan(BanName As String, IP As String, UnbanDate As Date, Reason As String, Optional ErrData As String)
    If IP = "" Then
        ErrData = "ErrNum=11" + vbCrLf + "ErrDesc=An IP must be entered" + vbCrLf + "Name=EditBan"
        Exit Sub
    End If

    If BanRS.RecordCount > 0 Then
        BanRS.FindFirst "Name='" + BanName + "'"
        
        If BanRS.NoMatch = True Then
            ErrData = "ErrNum=10" + vbCrLf + "ErrDesc=The ban name specified doesn't exists" + vbCrLf + "Name=EditBan"
            Exit Sub
        End If
    End If
    
    BanRS.Edit
    
    'BanRS!Name = BanName
    BanRS!IP = IP
    BanRS!UnbanDate = UnbanDate
    
    If Reason <> "" Then
        BanRS!Reason = Reason
    Else
        BanRS!Reason = Null
    End If
    
    BanRS.Update
End Sub

Sub DeleteAccount(User As String, Optional ErrData As String)
    If ServerRS.RecordCount = 0 Then Exit Sub
    
    ServerRS.Seek "=", User
    
    If ServerRS.NoMatch = False Then
        ServerRS.Delete
    Else
        ErrData = "ErrNum=12" + vbCrLf + "ErrDesc=The account specified does not exist" + vbCrLf + "Name=DeleteAccount"
    End If
End Sub

Sub DeleteBan(BanName As String, Optional ErrData As String)
    If BanRS.RecordCount = 0 Then Exit Sub
    
    BanRS.FindFirst "Name='" + BanName + "'"
    
    If BanRS.NoMatch = False Then
        BanRS.Delete
    Else
        ErrData = "ErrNum=13" + vbCrLf + "ErrDesc=The ban specified does not exist" + vbCrLf + "Name=DeleteBan"
    End If
End Sub

Function OptionText(OptionNum As Integer) As String
    Select Case OptionNum
        Case 1 'Send Message
            OptionText = "Send Message - for sending messages to servers connected to the registry"
        Case 2 'Send Message (All Servers)
            OptionText = "Send Message (All Servers) - for sending a message to all servers connected to the registry"
        Case 3 'Add Account
            OptionText = "Add Account - for creating a new server account"
        Case 4 'Edit Account
            OptionText = "Edit Account - for editing an existing server account"
        Case 5 'Delete Account
            OptionText = "Delete Account - for deleting an existing server account"
        Case 6 'View Accounts
            OptionText = "View Accounts - for viewing existing accounts"
        Case 7 'Add Ban
            OptionText = "Add Ban - for creating an IP ban"
        Case 8 'Edit Ban
            OptionText = "Edit Ban - for editing an existing IP ban"
        Case 9 'Delete Ban
            OptionText = "Delete Ban - for deleting an existing IP ban"
        Case 10 'View Bans
            OptionText = "View Bans - for viewing existing IP bans"
        Case 11 'Boot Server
            OptionText = "Boot Server - for booting servers connected to the registry"
        Case 12 'Shutdown Registry
            OptionText = "Shutdown Registry - for exiting from the registry"
    End Select
End Function

Function OptionCount() As Integer
    OptionCount = TotalOptions
End Function

Private Sub Class_Initialize()
    Set ServerList = frmMain.lstServers
End Sub
