Attribute VB_Name = "modServerRegistry"
Option Explicit

'Game Constants
Public Const MAX_COMPUTERNAME_LENGTH As Long = 15&
Public Const TitleString = "The Odyssey Classic Server Registry"
Public Const MaxClients = 255
Public Const ServerPort = 5679
Public Const OverlapClient = MaxClients + 1
#Const Irc = False

Public Const modeNotConnected = 0
Public Const modeOperator = 1
Public Const modeServer = 2

Public MSGNotice As String
'Function used to get the handle of the foreground window
Public Declare Function GetForegroundWindow Lib "user32.dll" () As Long

'INI File Related
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long




'User Defined Types
Type ClientData
    'Socket Data
    SocketData As String
    InUse As Boolean
    Mode As Byte
    LastMsg As Long
    
    'Account Data
    User As String
    Access As Byte
    
    'Misc Data
    PlayerCount As Byte
    MaxPlayers As Byte
    
    Name As String
    IP As String
    Description As String
    UpdateURL As String
    TileSet As Byte
    
    Official As Byte
    Date As Long
    Time As Long
    
    Bookmark As Variant
    Updated As Boolean
    
    CloseAfterSend As Boolean
End Type

'Registry Link Variables
Type LinkData
    Linked As Boolean
End Type
Public LinkReg As LinkData

Type OptionData
    Service As Boolean 'Run as service at startup
    AutoAllow As Boolean 'Allow new accounts at startup
End Type

Public OPTIONS As OptionData
Public NumClients As Long
Public Client(1 To MaxClients + 1) As ClientData

'Database Objects
Public WS As Workspace
Public DB As Database
Public ServerRS As Recordset
Public BanRS As Recordset
Public AdminRS As Recordset
Public SrvrVersion As Long

Declare Function GetTickCount Lib "kernel32" () As Long

Public Const GWL_WNDPROC = -4
Public lpPrevWndProc As Long
Public gHW As Long

'Tray Icon
Public Type NOTIFYICONDATA
   cbSize As Long
   hWnd As Long
   uID As Long
   uFlags As Long
   uCallbackMessage As Long
   hIcon As Long
   szTip As String * 128
   dwState As Long
   dwStateMask As Long
   szInfo As String * 256
   uTimeout As Long
   szInfoTitle As String * 64
   dwInfoFlags As Long
End Type

'Tray Icon
Public Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean

'Tray Icon
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205

'Tray Icon
Public Const NIS_HIDDEN = &H1
Public Const NIS_SHAREDICON = &H2
Public Const NIM_ADD = &H0
Public Const NIM_MODIFY = &H1
Public Const NIM_DELETE = &H2
Public Const WM_MOUSEMOVE = &H200
Public Const NIF_MESSAGE = &H1
Public Const NIF_ICON = &H2
Public Const NIF_TIP = &H4
Public Const NIF_STATE = &H8
Public Const NIF_INFO = &H10

'Tray Icon -  our NOTIFYICONDATA variable.
Public t As NOTIFYICONDATA

' Tray Icon - list the icon types for the balloon message..
Public Const vbNone = 0
Public Const vbInformation = 1
Public Const vbExclamation = 2
Public Const vbCritical = 3

'Mouse Event API Call
Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cButtons As Long, ByVal dwExtraInfo As Long)

'Mouse Event Constants
Public Const MOUSEEVENTF_LEFTDOWN = &H2
Public Const MOUSEEVENTF_LEFTUP = &H4
Public Const MOUSEEVENTF_MIDDLEDOWN = &H20
Public Const MOUSEEVENTF_MIDDLEUP = &H40
Public Const MOUSEEVENTF_MOVE = &H1
Public Const MOUSEEVENTF_ABSOLUTE = &H8000
Public Const MOUSEEVENTF_RIGHTDOWN = &H8
Public Const MOUSEEVENTF_RIGHTUP = &H10

Public EditMode As Long
Public Section(1 To 10) As String
Public AccessTime(1 To 100) As Long
Public AccessCount As Long

Sub GetSections(St, Deliminator As String)
    Dim a As Integer, B As Integer, C As Integer
    B = 1
    Erase Section
    For a = 1 To 10
TryAgain:
        C = InStr(B, St, Deliminator)
        If C - B = 0 Then B = B + 1: GoTo TryAgain
        If C <> 0 Then
                Section(a) = Mid$(St, B, C - B)
        Else
                Section(a) = Mid$(St, B, Len(St) - B + 1)
                Exit For
        End If
        B = C + 1
    Next a
End Sub

Sub CloseClientSocket(Index As Long)
    Dim a As Long
    
    With Client(Index)
        If .InUse = True Then
            'Decrement Server Num
            NumClients = NumClients - 1
            frmMain.Caption = TitleString + " [" + CStr(NumClients) + "]"
            UpdateTrayIconText "OdyRegistry [" + CStr(NumClients) + "]"
            
            'Close Socket
            frmMain.wsServer(Index).Close
            Unload frmMain.wsServer(Index)
            
            If .Mode = modeServer Then
                PrintOutput .User + " has disconnected from " + .IP
                IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> 4" & .Name & " disconnected from the server registry." & vbCrLf
                SendToOperators Chr$(6) + .User
                
                
                With frmMain.lstServers
                    For a = 0 To .ListCount - 1
                        If .List(a) = Client(Index).User Then
                            If a = .ListIndex Then
                                'frmMain.btnSend.Enabled = False
                            End If
                            .RemoveItem a
                            Exit For
                        End If
                    Next a
                    
                    If .ListCount = 0 Then
                        With frmMain
                            '.btnSend.Enabled = False
                            '.btnSendAll.Enabled = False
                            '.txtMessage.Enabled = False
                            '.txtMessage.BackColor = QBColor(7)
                        End With
                    End If
                End With
            ElseIf .Mode = modeOperator Then
                PrintOutput "Operator has disconnected from " + .IP
            End If
            
            'Clear Socket Data
            .IP = ""
            .InUse = False
            .SocketData = ""
            .User = ""
            .Name = ""
            .Mode = modeNotConnected
            .CloseAfterSend = False
        End If
    End With
End Sub

Function FindServer(ByVal Name As String) As Long
    Dim a As Long
    Name = UCase$(Name)
    
    For a = 1 To MaxClients
        With Client(a)
            If .Mode = modeServer Then
                If UCase$(.User) = Name Then
                    FindServer = a
                    Exit Function
                End If
            End If
        End With
    Next a
End Function

Sub Main()
    LoadOptions
    IRCServer = "Irc.enterthegame.com"
    IRCPort = 6667
    IRCAdminChannel = "#OdyAdmins"
    IRCOfficalChannel = "#Odyssey"
    Randomize Timer
    Dim a As Long, B As Long
    
    Dim strPath As String
    Dim strText As String
    Dim intPosition As Integer
    
    'replace this with your file path
    'strPath = "noticement.txt"
    'replace this with the position of the first mystery character in the file
    intPosition = 17

   ' Open strPath For Binary As #1
   ' MSGNotice = Space$(LOF(1))
   ' Get #1, , MSGNotice
   ' Close #1

    AllowToAnnounce = True
    
    B = GetTickCount()
    For a = 1 To 100
        AccessTime(a) = B
    Next a
    
    'Listens for other registry connections "link"
    'frmMain.WLink.LocalPort = 56790
    'frmMain.WLink.Listen
    'frmMain.mnuLink.Caption = "&DeLink"
    
    Dim St As String
    
    Set WS = DBEngine.Workspaces(0)
    If Exists(App.Path + "\ocsr.dat") Then
        If Exists("ocsr.tmp") Then Kill "ocsr.tmp"
        Name App.Path + "\ocsr.dat" As "ocsr.tmp"
        RepairDatabase "ocsr.tmp"
        CompactDatabase "ocsr.tmp", App.Path + "\ocsr.dat"
        Kill "ocsr.tmp"
        Set DB = WS.OpenDatabase(App.Path + "\ocsr.dat")
    Else
        CreateDatabase
    End If
       
    Set ServerRS = DB.TableDefs("Servers").OpenRecordset(dbOpenTable)
    Set BanRS = DB.TableDefs("Bans").OpenRecordset(dbOpenDynaset)
    'Set AdminRS = DB.OpenRecordset("Admin", dbOpenDynaset)
    
    ServerRS.Index = "User"
    'BanRS.Index = "Number"
    
    Load frmMain
    
    If OPTIONS.AutoAllow = True Then frmMain.mnuAccountsNew.Checked = True
    If OPTIONS.Service = True Then frmMain.Service.StartService
    
    frmMain.Caption = TitleString + " [0]"
    Hook
    'StartWinsock St
    #If Irc = True Then
    frmMain.WSIRC.Connect IRCServer, IRCPort
    #End If
    frmMain.wsServer(0).LocalPort = ServerPort
    frmMain.wsServer(0).Listen
    
    If GetForegroundWindow <> 0 Then
        frmMain.Show
        StartTrayIcon
    End If
    
    'With frmMain.X10
    '    .comport = 1
    '    .Init
    'End With
    
    PrintOutput "OdyRegistry v" + CStr(App.Major) + "." + CStr(App.Minor) + "." + CStr(App.Revision) + " has loaded and is listening on port " + CStr(ServerPort) + " for connections."
    #If Irc = True Then
    frmMain.lstOutput.AddItem "*** IRC Loading and Connecting.."
    #End If
End Sub

Public Sub Hook()
#If DEBUGWINDOWPROC Then
    On Error Resume Next
    Set m_SCHook = CreateWindowProcHook
    If Err Then
        MsgBox Err.Description
        Err.Clear
        Unhook
        Exit Sub
    End If
    On Error GoTo 0
    'With m_SCHook
    '    .SetMainProc AddressOf WindowProc
    '    lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, .ProcAddress)
    '    .SetDebugProc lpPrevWndProc
    'End With
#Else
    'lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
#End If
End Sub
Public Sub IRCSend(ByVal Data As String)
#If Irc = True Then
    If frmMain.WSIRC.State = 7 Then
        frmMain.WSIRC.SendData Data
    Else
        FrmIRC.lstStatus.Text = "*** ERROR: NOT CONNECTED"
    End If
#End If
End Sub
Public Sub Unhook()
    'SetWindowLong gHW, GWL_WNDPROC, lpPrevWndProc
End Sub

Sub ShutdownServer()
    Dim a As Long
    
    On Error Resume Next
    
    For a = 1 To MaxClients
        If Client(a).InUse = True Then
            CloseClientSocket a
        End If
    Next a
    
    frmMain.tmrGeneral = False
    
    ServerRS.Close
    BanRS.Close
    DB.Close
    WS.Close
    frmMain.WLink.Close
    'If ListeningSocket <> INVALID_SOCKET Then
    '    closesocket ListeningSocket
    'End If
    'EndWinsock
    EndTrayIcon
    Unhook
    
    Unload frmMain
    Unload frmAccount
    Unload frmAccount
    Unload frmOptions
    Unload frmMessage
    End
End Sub

Function Exists(Filename As String) As Boolean
     Exists = (Dir(Filename) <> "")
End Function

Sub ReadClientData(St As String, Index As Long)
    Dim SocketData As String, PacketLength As Long, PacketID As Long
    Dim a As Long, B As Long, C As Long
    Dim St1 As String, St2 As String
    
    With Client(Index)
        SocketData = .SocketData + St
        .LastMsg = GetTickCount
LoopRead:
        If Len(SocketData) >= 3 Then
            PacketLength = GetInt(Mid$(SocketData, 1, 2))
            If PacketLength >= 512 Then
                CloseClientSocket Index
                Exit Sub
            End If
            If Len(SocketData) - 2 >= PacketLength Then
                St = Mid$(SocketData, 3, PacketLength)
                SocketData = Mid$(SocketData, PacketLength + 3)
                If PacketLength > 0 Then
                    PacketID = Asc(Mid$(St, 1, 1))
                    If Len(St) > 1 Then
                        St = Mid$(St, 2)
                    Else
                        St = ""
                    End If
                    Select Case .Mode
                        Case modeNotConnected
                            Select Case PacketID
                                Case 0 'New Server Account
                                    If Len(St) >= 1 Then
                                        a = InStr(1, St, Chr$(0))
                                        If a > 1 And a < Len(St) Then
                                            St1 = Trim$(Mid$(St, 1, a - 1))
                                            B = Len(St1)
                                            If B >= 3 And B <= 15 And ValidName(St1) And InStr(St1, " ") = 0 Then
                                                If frmMain.mnuAccountsNew.Checked = False Then
                                                    SendSocket Index, Chr$(3) 'Invalid User/Password
                                                    CloseClientSocket Index
                                                Else
                                                    ServerRS.Index = "User"
                                                    ServerRS.Seek "=", St1
                                                    If ServerRS.NoMatch = True Then
                                                        ServerRS.AddNew
                                                        ServerRS!User = St1
                                                        .User = St1
                                                        'St1 = Trim$(UCase$(Mid$(St, a + 1)))
                                                        C = InStr(a + 1, St, Chr$(0))
                                                        If C > 0 Then
                                                            St1 = Trim$(UCase$(Mid$(St, a + 1, C - a - 1)))
                                                        Else
                                                            St1 = Trim$(UCase$(Mid$(St, a + 1)))
                                                        End If
                                                        If Len(St1) > 15 Then
                                                            ServerRS!Password = Left$(St1, 15)
                                                        Else
                                                            ServerRS!Password = St1
                                                        End If
                                                        If C > 0 Then
                                                            St1 = Trim$(Mid$(St, C + 1, 1))
                                                            If Asc(St1) >= 0 And Asc(St1) <= 255 Then
                                                                .TileSet = Asc(St1)
                                                            Else
                                                                .TileSet = 0
                                                            End If
                                                        Else
                                                            .TileSet = 0
                                                        End If
                                                        PrintOutput "New account " + .User + " created from " + .IP
                                                        
                                                        .Name = "New Untitled Server "
                                                        .Description = "New Server created at " & Date
                                                        .Official = 0
                                                        .UpdateURL = ""
                                                        .Date = Date
                                                        .Time = Time
                                                        
                                                        
                                                        
                                                        ServerRS!Name = .Name
                                                        ServerRS!Description = .Description
                                                        ServerRS!Official = .Official
                                                        ServerRS!UpdateURL = .UpdateURL
                                                        frmMain.lstServers.AddItem .User
                                                        .Mode = modeServer
                                                    
                                                        ServerRS.Update
                                                        ServerRS.Seek "=", .User
                                                        .Bookmark = ServerRS.Bookmark
                                                        SendSocket Index, Chr$(0) + .Name + Chr$(0) + .Description
                                                        IRCSend "PRIVMSG " & IRCAdminChannel & "Registry Console >> New Registry Account4 " & .Name & " has been create at" & Date & ", " & Time & vbCrLf
                                                        
                                                    Else
                                                        SendSocket Index, Chr$(1) 'User Already Exists
                                                        IRCSend "PRIVMSG " & IRCAdminChannel & " :" & .IP & " failed to create new account." & vbCrLf
                                                        CloseClientSocket Index
                                                    End If
                                                End If
                                            Else
                                                CloseClientSocket Index
                                            End If
                                        Else
                                            CloseClientSocket Index
                                        End If
                                    Else
                                        CloseClientSocket Index
                                    End If
                                    
                                Case 1 'Server Log on
                                    If Len(St) >= 1 Then
                                        a = InStr(1, St, Chr$(0))
                                        If a > 1 And a < Len(St) Then
                                            .User = Mid$(St, 1, a - 1)
                                            ServerRS.Seek "=", .User
                                            If ServerRS.NoMatch = False Then
                                                C = InStr(a + 1, St, Chr$(0))
                                                If C > 0 Then
                                                    St1 = Trim$(UCase$(Mid$(St, a + 1, C - a - 1)))
                                                Else
                                                    St1 = Trim$(UCase$(Mid$(St, a + 1)))
                                                End If
                                                If UCase$(St1) = UCase$(ServerRS!Password) Then
                                                    B = 0
                                                    St1 = UCase$(.User)
                                                    For a = 1 To MaxClients
                                                        If St1 = UCase$(Client(a).User) And a <> Index Then
                                                            B = 1
                                                            Exit For
                                                        End If
                                                    Next a
                                                    'Only allows the new version servers to connect
                                                    If B = 0 Then
                                                        If C > 0 Then
                                                            St1 = Mid$(St, C + 1, 1)
                                                            If Asc(St1) >= 0 And Asc(St1) <= 255 Then
                                                                .TileSet = Asc(St1)
                                                            Else
                                                                .TileSet = 0
                                                            End If
                                                        Else
                                                            .TileSet = 0
                                                        End If
                                                        .Name = ServerRS!Name
                                                        .Description = ServerRS!Description
                                                        .Official = ServerRS!Official
                                                        .UpdateURL = ServerRS!UpdateURL
                                                        frmMain.lstServers.AddItem .User
                                                        .Mode = modeServer
                                                        .Bookmark = ServerRS.Bookmark
                                                        SendSocket Index, Chr$(0) + .Name + Chr$(0) + .Description

                                                        PrintOutput .User + " has connected successfully from " + .IP
                                                        IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> 4" & .Name & " successfully connected to the server registry." & vbCrLf
                                                        
                                                        For a = 1 To MaxClients
                                                        With Client(a)
                                                        If .Mode = modeServer Then
                                                        'SendSocket a, Chr$(4) + "[Registry Auto-Noticement]" & vbCrLf
                                                        'SendSocket a, Chr$(4) + ">> " & MSGNotice & vbCrLf
                                                        End If
                                                        End With
                                                        Next a

                                                        
                                                    Else
                                                        SendSocket Index, Chr$(2) 'Account already in use
                                                        CloseClientSocket Index
                                                    End If
                                                Else
                                                    Client(Index).CloseAfterSend = True
                                                    SendSocket Index, Chr$(3) 'Invalid User/Password
                                                    IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> 12" & .IP & " has entered an invalid User/Password!" & vbCrLf
                                                End If
                                            Else
                                                Client(Index).CloseAfterSend = True
                                                SendSocket Index, Chr$(3) 'Invalid User/Password
                                                IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> 12" & .IP & " has entered an invalid User/Password!" & vbCrLf
                                            End If
                                        Else
                                            CloseClientSocket Index
                                        End If
                                    Else
                                        CloseClientSocket Index
                                    End If
                                    
                                Case 2 'Operator Log On
                                    a = InStr(1, St, Chr$(0))
                                    If a > 1 And a < Len(St) Then
                                        If UCase$(Mid$(St, 1, a - 1)) = "Tsdfjasldfjasdfsdaffsdasdf" Then
                                            If UCase$(Mid$(St, a + 1)) = "WEasdfgodfgjsgddgs" Then
                                                SendSocket Index, Chr$(5) 'Operator log on OK
                                                .Mode = modeOperator
                                                PrintOutput "Operator connection established from " + .IP
                                            Else
                                               CloseClientSocket Index
                                            End If
                                        Else
                                            CloseClientSocket Index
                                        End If
                                    Else
                                        CloseClientSocket Index
                                    End If
                                
                                Case 3 'Server List
                                    If Len(St) = 1 Then
                                        a = Asc(St)
                                        If a >= 1 And a <= MaxClients Then
                                            St2 = ""
                                            For B = a To MaxClients
                                                With Client(B)
                                                    If .Mode = modeServer Then
                                                        If Len(St2) >= 1024 Then Exit For
                                                        If .Official Then
                                                            St1 = Chr$(4) + .User + Chr$(0) + .IP + Chr$(0) + "[" + CStr(.PlayerCount) + "] " + .Name + Chr$(0) + "Official Server: " + .Description + Chr$(0) + .UpdateURL + Chr$(0) + Chr$(.TileSet)
                                                            St2 = DoubleChar(Len(St1)) + St1 + St2
                                                        Else
                                                            St1 = Chr$(4) + .User + Chr$(0) + .IP + Chr$(0) + "[" + CStr(.PlayerCount) + "] " + .Name + Chr$(0) + "Unofficial Server: " + .Description + Chr$(0) + .UpdateURL + Chr$(0) + Chr$(.TileSet)
                                                            St2 = St2 + DoubleChar(Len(St1)) + St1
                                                        End If
                                                        
                                                    End If
                                                End With
                                            Next B
                                            If St2 <> "" Then
                                                If B = MaxClients + 1 Then
                                                    St2 = St2 + DoubleChar(2) + Chr$(255) + Chr$(4)
                                                Else
                                                    St2 = St2 + DoubleChar(3) + Chr$(255) + Chr$(3) + Chr$(B)
                                                End If
                                                PrintOutput "Server information sent to " + .IP
                                                
                                                SendRaw Index, St2
                                                
                                                'frmMain.X10.Exec "D", "4", "2"
                                                'frmMain.X10.Exec "D", "4", "3"
                                            Else
                                                CloseClientSocket Index
                                            End If
                                        End If
                                    Else
                                        CloseClientSocket Index
                                    End If
                                
                                Case 4 'Disconnect
                                    CloseClientSocket Index
                                    
                                Case 255 'Pong
                                    If Len(St) > 0 Then
                                        CloseClientSocket Index
                                    End If
                                    
                                Case Else
                                    CloseClientSocket Index
                            End Select
                        Case modeOperator
                            Select Case PacketID
                                Case 5 'Boot Server
                                    a = FindServer(St)
                                    If a > 0 Then CloseClientSocket a
                                Case 6 'Global Message
                                    If Len(St) > 2 Then
                                        a = InStr(1, St, Chr$(0))
                                        If a > 1 And a < Len(St) Then
                                            B = FindServer(UCase$(Mid$(St, 1, a - 1)))
                                            If B > 0 Then
                                                SendSocket B, Chr$(4) + UCase$(Mid$(St, a + 1))
                                            End If
                                        End If
                                    End If
                                Case 7 'Global Message All Servers
                                    If Len(St) > 0 Then
                                        PrintOutput "Operator: " + St
                                        For a = 1 To MaxClients
                                            With Client(a)
                                                If .Mode = modeServer Then
                                                    SendSocket a, Chr$(4) + St
                                                End If
                                            End With
                                        Next a
                                    End If
                                Case 8 'Ban Server
                                Case 9 'Give Access
                                    If Len(St) > 3 Then
                                        a = InStr(1, St, Chr$(0))
                                        If a > 1 And a < Len(St) Then
                                            B = FindServer(UCase$(Mid$(St, 1, a - 1)))
                                            If B > 0 Then
                                                SendSocket B, Chr$(5) + Chr$(10) + UCase$(Mid$(St, a + 1))
                                            End If
                                        End If
                                    End If
                                Case 10 'Make Official
                                    If Len(St) >= 3 Then
                                        a = InStr(1, St, Chr$(0))
                                        If a > 1 And a < Len(St) Then
                                            B = FindServer(UCase$(Mid$(St, 1, a - 1)))
                                            If B > 0 Then
                                                Client(B).Official = 1
                                            End If
                                        End If
                                    End If
                                Case 11 'Make Unofficial
                                    If Len(St) >= 3 Then
                                        a = InStr(1, St, Chr$(0))
                                        If a > 1 And a < Len(St) Then
                                            B = FindServer(UCase$(Mid$(St, 1, a - 1)))
                                            If B > 0 Then
                                                Client(B).Official = 0
                                            End If
                                        End If
                                    End If
                                Case 12 ' lock registry
                                    frmMain.mnuAccountsNew.Checked = False
                                Case 13 'unlock registry
                                    frmMain.mnuAccountsNew.Checked = True
                                Case 14 'reset official
                                    If Not ServerRS.BOF Then
                                    ServerRS.MoveFirst
                                        While Not ServerRS.EOF
                                            ServerRS!Official = 0
                                            ServerRS.MoveNext
                                        Wend
                                    End If
                                Case 15 'Reset Accounts
                                If Not ServerRS.BOF Then
                                    ServerRS.MoveFirst
                                        While Not ServerRS.EOF
                                            ServerRS.Delete
                                            ServerRS.MoveNext
                                        Wend
                                    End If
                                Case 16 'Using Updated Server
                                .Updated = True
                                Case 17 '
                                
                                
                               ' Case 18 'Check Ocsr.dat Database
                               ' a = InStr(1, St, Chr$(0))
                               ' If LinkReg.Linked = True Then
                               '   If .Date = Mid$(St, 1, a - 1) Then ' Checks if Linked Registry has the same Date
                               '     If .Time = Mid$(St, 1, a + 1) Then ' Checks if Linked Registry has the same Time
                               '        frmMain.WLink.SendData Chr$(19) + "1111" 'Database is correct
                               '     Else
                               '     frmMain.WLink.SendData Chr$(20) + "11111" 'Date or Time does not match, need update
                               '     End If
                               '   End If
                               '   Else
                               '   frmMain.lstOutput.AddItem "*Error: You are not linked to check database informations"
                               ' End If
                               '
                               ' Case 19 'Database Matches
                               ' frmMain.lstOutput.AddItem "-Database is correct with linked registry"
                               ' LinkReg.Linked = True
                               '
                               ' Case 20 'Date or Time does not match, need update
                               ' frmMain.lstOutput.AddItem "-Database does not match with linked registry.."
                               ' frmMain.WLink.SendData Chr$(13) + "INeedUpdates"
                               ' frmMain.lstOutput.AddItem "-Database is now updating from linked registry.."
                               '
                               ' Case 21 'Update Registry to Linked Registry
                               ' 'Server Database
                               ' frmMain.WLink.SendData Chr$(17)
                               ' 'Bans Database
                               '
                               ' Case 22 'Update: Record Data
                                
                                Case 27 'PING
                                
                                Case 28 'Server Version 12.01+
                                If Mid$(St, 1, a + 1) = SrvrVersion Then
                                .Updated = True
                                Else
                                SendSocket Index, Chr$(4) + "You must upgrade to v12.01 or higher."
                                'SendSocket Index, Chr$(68)
                                CloseClientSocket Index
                                End If
                                
                                Case 255 'Pong
                                    If Len(St) > 0 Then
                                        CloseClientSocket Index
                                    End If
                                    
                                Case Else
                                    CloseClientSocket Index
                            End Select
                        Case modeServer
                            Select Case PacketID
                                Case 5 'Change Name / Description
                                    a = InStr(1, St, Chr$(0))
                                    St1 = Trim$(Mid$(St, 1, a - 1))
                                    St2 = Trim$(Mid$(St, a + 1))
                                    If Len(St1) <= 50 And Len(St2) <= 255 Then
                                        ServerRS.Bookmark = .Bookmark
                                        ServerRS.Edit
                                        ServerRS!Name = St1
                                        .Name = St1
                                        .Description = St2
                                        ServerRS!Name = .Name
                                        ServerRS!Description = .Description
                                        ServerRS.Update
                                        .Time = Time
                                        .Date = Date
                                        If .Description = "" Then
                                        IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> Server 4" & .Name & ", Description:12" & " has no description entered." & "" & vbCrLf
                                        Else
                                        IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> Server 4" & .Name & ", changed description: 12" & .Description & "" & vbCrLf
                                        End If
                                    Else
                                        CloseClientSocket Index
                                    End If
                                    
                                Case 6 'Change Password
                                    a = Len(St)
                                    If a >= 3 And a <= 15 Then
                                        ServerRS.Bookmark = .Bookmark
                                        ServerRS.Edit
                                        ServerRS!Password = UCase$(St)
                                        ServerRS.Update
                                        .Time = Time
                                        .Date = Date
                                    End If
                                    
                                Case 7 'Change player count
                                    If Len(St) = 1 Then
                                        .PlayerCount = Asc(St)
                                        If AllowToAnnounce = True Then ' Prevents From Flooding IRC
                                        a = FindServer(.Name)
                                        If a > 0 Then
                                        IRCSend "PRIVMSG " & IRCAdminChannel & " :Registry Console >> 4" & .Name & " has 12" & .PlayerCount & " active players." & vbCrLf
                                        AllowToAnnounce = False
                                        End If
                                      End If
                                    Else
                                        CloseClientSocket Index
                                    End If
                                Case 8 'Change Tileset Number
                                    If Len(St) = 1 Then
                                        .TileSet = Asc(St)
                                    Else
                                        CloseClientSocket Index
                                    End If
                                
                                Case 255 'Pong
                                    If Len(St) > 0 Then
                                        CloseClientSocket Index
                                    End If
                                    
                                Case Else
                                    CloseClientSocket Index
                            End Select
                    End Select
                End If
                GoTo LoopRead
            End If
        End If
        .SocketData = SocketData
    End With
    
    If modServerRegistry.Client(Index).Mode = modeServer Then
        If frmMain.lstServers.Text <> "" Then
            If frmMain.lstServers = Client(Index).User Then
                a = FindServer(frmMain.lstServers.Text)
                If a > 0 Then UpdateStats a
            End If
        End If
    End If
End Sub
Sub SendRaw(ByVal Index As Long, ByVal St As String)
    With Client(Index)
        If .InUse = True Then
            If frmMain.wsServer(Index).State = sckConnected Then
                frmMain.wsServer(Index).SendData St
            Else
                CloseClientSocket Index
            End If
        End If
    End With
End Sub

Sub SendSocket(ByVal Index As Long, ByVal St As String)
    With Client(Index)
        If .InUse = True Then
            If frmMain.wsServer(Index).State = sckConnected Then
                frmMain.wsServer(Index).SendData DoubleChar(Len(St)) + St
            Else
                CloseClientSocket Index
            End If
        End If
    End With
End Sub

Sub SendToOperators(ByVal St As String)
    Dim a As Long
    For a = 1 To MaxClients
        With Client(a)
            If .Mode = modeOperator Then
                SendRaw a, DoubleChar(Len(St)) + St
            End If
        End With
    Next a
End Sub

Function DoubleChar(Num As Long) As String
    DoubleChar = Chr$(Int(Num / 256)) + Chr$(Num Mod 256)
End Function

Function GetInt(Chars As String) As Long
    GetInt = Asc(Mid$(Chars, 1, 1)) * 256& + Asc(Mid$(Chars, 2, 1))
End Function

Function ValidName(St As String) As Boolean
    Dim a As Long, B As Long
    If Len(St) > 0 Then
        For a = 1 To Len(St)
            B = Asc(Mid$(St, a, 1))
            If (B < 48 Or B > 57) And (B < 65 Or B > 90) And (B < 97 Or B > 122) And B <> 32 And B <> 95 Then
                ValidName = False
                Exit Function
            End If
        Next
    End If
    ValidName = True
End Function

Sub CreateDatabase()
    Dim a As Long
    Dim Td As TableDef
    Dim NewField As Field
    Dim NewIndex As Index
        
    'Create Database
    Set DB = WS.CreateDatabase(App.Path + "\ocsr.dat", dbLangGeneral, dbVersion30)
    
    CreateServersTable
    CreateBansTable
    CreateAdminTable
End Sub

Sub CreateBansTable()
    Dim Td As TableDef
    Dim NewField As Field
    Dim NewIndex As Index

    'Create Bans Table
    Set Td = DB.CreateTableDef("Bans")
    Set NewField = Td.CreateField("Number", dbByte)
    Td.Fields.Append NewField
    
    Set NewField = Td.CreateField("Name", dbText, 15)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    
    Set NewField = Td.CreateField("IP", dbText, 15)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    
    Set NewField = Td.CreateField("Reason", dbText, 255)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    
    Set NewField = Td.CreateField("UnbanDate", dbDate)
    Td.Fields.Append NewField
    
    'Create Indexes
    Set NewIndex = Td.CreateIndex("Number")
    NewIndex.Primary = True
    NewIndex.Unique = True
    Set NewField = NewIndex.CreateField("Number")
    NewIndex.Fields.Append NewField
    Td.Indexes.Append NewIndex
    
    'Append Bans Table
    DB.TableDefs.Append Td
End Sub

Sub CreateServersTable()
    Dim Td As TableDef
    Dim NewField As Field
    Dim NewIndex As Index

    'Create Bans Table
    Set Td = DB.CreateTableDef("Servers")
    Set NewField = Td.CreateField("User", dbText, 15)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("Password", dbText, 15)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("Name", dbText, 50)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("Description", dbText, 255)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("UpdateURL", dbText, 255)
    NewField.AllowZeroLength = True
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("Official", dbByte)
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("Date", dbByte)
    Td.Fields.Append NewField
    Set NewField = Td.CreateField("Time", dbByte)
    Td.Fields.Append NewField
    'Create Indexes
    Set NewIndex = Td.CreateIndex("User")
    NewIndex.Primary = True
    NewIndex.Unique = True
    Set NewField = NewIndex.CreateField("User")
    NewIndex.Fields.Append NewField
    Td.Indexes.Append NewIndex
    
    'Append Servers Table
    DB.TableDefs.Append Td
End Sub

Function QuadChar(Num As Long) As String
    QuadChar = Chr$(Int(Num / 16777216) Mod 256) + Chr$(Int(Num / 65536) Mod 256) + Chr$(Int(Num / 256) Mod 256) + Chr$(Num Mod 256)
End Function

Function FreeClient() As Long
    Dim a As Long
    For a = 1 To MaxClients
        If Client(a).InUse = False Then
            FreeClient = a
            Exit Function
        End If
    Next a
End Function

Sub LoadOptions()
    Dim TempSt As String
    
    With OPTIONS
        TempSt = ReadOption("Service")
        If TempSt = "" Then TempSt = "False"
        .Service = CBool(TempSt)
        
        TempSt = ReadOption("AutoAllow")
        If TempSt = "" Then TempSt = "False"
        .AutoAllow = CBool(TempSt)
    End With
End Sub

Function ReadInt(lpAppName, lpKeyName$, lpFile) As Integer
    ReadInt = GetPrivateProfileInt&(lpAppName, lpKeyName$, 0, App.Path + lpFile)
End Function

Sub WriteString(lpAppName, lpKeyName As String, a, lpFileName)
    Dim lpString As String, Valid As Long
    lpString = a
    Valid = WritePrivateProfileString&(lpAppName, lpKeyName, lpString, App.Path + lpFileName)
End Sub

Function ReadString(lpAppName, lpKeyName As String, lpFile As String) As String
    Dim lpReturnedString As String, Valid As Long
    lpReturnedString = Space$(256)
    Valid = GetPrivateProfileString&(lpAppName, lpKeyName, "", lpReturnedString, 256, App.Path + lpFile)
    ReadString = Left$(lpReturnedString, Valid)
End Function

Sub SaveOption(OptionName As String, OptionSetting As String)
    WriteString "OdyRegistry", OptionName, OptionSetting, "\server.ini"
End Sub

Function ReadOption(OptionName As String) As String
    ReadOption = ReadString("OdyRegistry", OptionName, "\server.ini")
End Function

Sub StartTrayIcon()
    With t
        .cbSize = Len(t)
        .uID = vbNull
        .hWnd = frmMain.hWnd
        .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE Or NIF_INFO
        .uCallbackMessage = WM_MOUSEMOVE
        .dwState = NIS_SHAREDICON
        .hIcon = frmMain.Icon
        .szTip = "OdyRegistry [0]" + Chr$(0)
        
        Shell_NotifyIcon NIM_ADD, t
    End With
End Sub

Sub EndTrayIcon()
    Shell_NotifyIcon NIM_DELETE, t
End Sub

Sub UpdateTrayIconText(St As String)
    t.szTip = St & vbNullChar
    Shell_NotifyIcon NIM_MODIFY, t
End Sub

Sub TrayIconNotify(St As String)
    With t
        .uTimeout = 5
        .dwInfoFlags = vbInformation
        .szInfoTitle = "OdyRegistry" & Chr$(0)
        .szInfo = St & Chr$(0)
        frmMain.Refresh
    End With

    Shell_NotifyIcon NIM_MODIFY, t
End Sub

Sub LeftClick()
    mouse_event MOUSEEVENTF_LEFTDOWN Or MOUSEEVENTF_LEFTUP, 0&, 0&, 0, 0
    DoEvents
End Sub

Sub UpdateStats(Index As Long)
    With frmMain
        .lblID = Client(Index).User
        .lblName = Client(Index).Name
        .lblIP = Client(Index).IP
        .lblCount = CStr(Client(Index).PlayerCount)
        
        If Client(Index).Official = 1 Then
            .lblOfficial = "Yes"
        Else
            .lblOfficial = "No"
        End If
    End With
End Sub

Function IsBanned(IP As String) As Boolean
    Dim a As Integer, BannedIP As String
        
    If BanRS.RecordCount = 0 Then Exit Function
    
    BanRS.FindFirst "IP='" + IP + "'"
    
    If BanRS.NoMatch = True Then
        BanRS.FindFirst "IP='" + FormatIP(IP, 1) + "'"
        
        If BanRS.NoMatch = True Then
            BanRS.FindFirst "IP='" + FormatIP(IP, 2) + "'"
            
            If BanRS.NoMatch = False Then
                IsBanned = True
            End If
        Else
            IsBanned = True
        End If
    Else
        IsBanned = True
    End If
End Function

Function BanExpired(UnbanDate As Date) As Boolean
    If DateDiff("d", Date, UnbanDate) <= 0 Then
        BanExpired = True
    End If
End Function

Function GetIPUnbanDate(IP As String) As Date
    If BanRS.RecordCount = 0 Then Exit Function
    
    BanRS.FindFirst "IP='" + IP + "'"
    
    If BanRS.NoMatch = True Then
        BanRS.FindFirst "IP='" + FormatIP(IP, 1) + "'"
        
        If BanRS.NoMatch = True Then
            BanRS.FindFirst "IP='" + FormatIP(IP, 2) + "'"
            
            If BanRS.NoMatch = False Then
                GetIPUnbanDate = BanRS!UnbanDate
            End If
        Else
            GetIPUnbanDate = BanRS!UnbanDate
        End If
    Else
        GetIPUnbanDate = BanRS!UnbanDate
    End If
End Function

Function FormatIP(IP As String, Section As Integer)
    Dim a As Integer

    FormatIP = IP

    Select Case Section
        Case 1
            a = InStrRev(IP, ".")
            If a > 0 Then
                FormatIP = Mid(IP, 1, a) + "0"
            End If
        Case 2
            a = InStrRev(IP, ".")
            If a = 0 Then Exit Function
            a = InStrRev(IP, ".", a - 1)
            If a > 0 Then FormatIP = Mid(IP, 1, a) + "0.0"
    End Select
End Function

Sub CheckForUpdate()
    If Dir(App.Path + "\regupdate.exe") <> "" Then
        If Dir(App.Path + "\updater.exe") <> "" Then
            Shell App.Path + "\updater.exe", vbNormalFocus
            ShutdownServer
        End If
    End If
End Sub

Sub AppendLog(St As String)
    Dim FF As Integer
    
    FF = FreeFile
    
    If FF = 0 Then Exit Sub
    
    Open App.Path + "\serverregistry.log" For Append As FF
        Print #FF, Date$ + " " + Time$ + " --> " + St
    Close FF
End Sub

Sub CreateAdminTable()

End Sub

Sub PrintOutput(St As String)
    With frmMain.lstOutput
        .AddItem St
        
        If .ListCount > 50 Then
            .RemoveItem 0
        End If
        
        .Selected(.ListCount - 1) = True
    End With
End Sub
